/*
 * ExactSubtreeAutomaton.h
 *
 *  Created on: 7. 4. 2015
 *      Author: Jan Travnicek
 */

#ifndef _EXACT_SUBTREE_AUTOMATON_H__
#define _EXACT_SUBTREE_AUTOMATON_H__

#include <automaton/AutomatonFeatures.h>
#include <tree/TreeFeatures.h>
#include <common/multipleDispatch.hpp>

namespace arbology {

namespace exact {

class ExactSubtreeAutomaton : public std::SingleDispatch < automaton::Automaton, tree::TreeBase > {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static automaton::Automaton construct ( const tree::Tree & tree );

	static automaton::InputDrivenNPDA construct ( const tree::PrefixRankedTree & tree );

	static ExactSubtreeAutomaton & getInstance ( ) {
		static ExactSubtreeAutomaton res;

		return res;
	}

};

} /* namespace exact */

} /* namespace arbology */

#endif /* _EXACT_SUBTREE_AUTOMATON_H__ */
