/*
 * ExactSubtreeMatchingAutomaton.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#ifndef _EXACT_SUBTREE_MATCHING_AUTOMATON_H__
#define _EXACT_SUBTREE_MATCHING_AUTOMATON_H__

#include <automaton/Automaton.h>
#include <automaton/AutomatonFeatures.h>
#include <tree/Tree.h>
#include <tree/TreeFeatures.h>
#include <common/multipleDispatch.hpp>

namespace arbology {

namespace exact {

class ExactSubtreeMatchingAutomaton : public std::SingleDispatch < automaton::Automaton, tree::TreeBase > {
public:
	ExactSubtreeMatchingAutomaton ( ) { }

	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static automaton::Automaton construct ( const tree::Tree & pattern );

	static automaton::InputDrivenNPDA construct ( const tree::PrefixRankedTree & pattern );
	static automaton::InputDrivenNPDA construct ( const tree::PrefixRankedBarTree & pattern );
	static automaton::NFTA construct ( const tree::RankedTree & pattern );

	static ExactSubtreeMatchingAutomaton & getInstance ( ) {
		static ExactSubtreeMatchingAutomaton res;

		return res;
	}

};

} /* namespace exact */

} /* namespace arbology */

#endif /* _EXACT_SUBTREE_MATCHING_AUTOMATON_H__ */
