/*
 * BeginToEndIndex.cpp
 *
 *  Created on: 5. 11. 2014
 *      Author: Jan Travnicek
 */

#include "BeginToEndIndex.h"
#include "../exact/SubtreeJumpTable.h"

#include <tree/Tree.h>
#include <tree/ranked/PrefixRankedBarTree.h>
#include <tree/ranked/PrefixRankedTree.h>

#include <map>

namespace arbology {

namespace transform {

std::set < unsigned > BeginToEndIndex::transform ( const tree::Tree & subject, const std::set < unsigned > & indexes ) {
	return getInstance ( ).dispatch ( subject.getData ( ), indexes );
}

std::set < unsigned > BeginToEndIndex::transform ( const tree::PrefixRankedBarTree & subject, const std::set < unsigned > & indexes ) {
	std::vector < int > subjectSubtreeJumpTable = exact::SubtreeJumpTable::compute ( subject );
	std::set < unsigned > res;

	for ( unsigned index : indexes )
		res.insert ( subjectSubtreeJumpTable[index] );

	return res;
}

auto BeginToEndIndexPrefixRankedBarTreePrefixRankedBarTree = BeginToEndIndex::RegistratorWrapper < std::set < unsigned >, tree::PrefixRankedBarTree > ( BeginToEndIndex::getInstance ( ), BeginToEndIndex::transform );

std::set < unsigned > BeginToEndIndex::transform ( const tree::PrefixRankedTree & subject, const std::set < unsigned > & indexes ) {
	std::vector < int > subjectSubtreeJumpTable = exact::SubtreeJumpTable::compute ( subject );
	std::set < unsigned > res;

	for ( unsigned index : indexes )
		res.insert ( subjectSubtreeJumpTable[index] );

	return res;
}

auto BeginToEndIndexPrefixRankedBarTreePrefixRankedBarPattern = BeginToEndIndex::RegistratorWrapper < std::set < unsigned >, tree::PrefixRankedTree > ( BeginToEndIndex::getInstance ( ), BeginToEndIndex::transform );

} /* namespace transform */

} /* namespace arbology */
