/*
 * Result.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#ifndef _AUTOMATON_RESULT_H__
#define _AUTOMATON_RESULT_H__

#include <common/multipleDispatch.hpp>
#include <automaton/Automaton.h>
#include <string/LinearString.h>
#include <object/Object.h>
#include <label/Label.h>
#include <tree/ranked/RankedTree.h>

namespace automaton {

namespace run {

class Result : public std::DoubleDispatch < label::Label, automaton::AutomatonBase, alib::ObjectBase > {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static label::Label result ( const automaton::Automaton & automaton, const alib::Object & object );

	static label::Label result ( const automaton::DFA & automaton, const string::LinearString & string );
	static label::Label result ( const automaton::DFTA & automaton, const tree::RankedTree & tree );
	static label::Label result ( const automaton::InputDrivenDPDA & automaton, const string::LinearString & string );
	static label::Label result ( const automaton::VisiblyPushdownDPDA & automaton, const string::LinearString & string );
	static label::Label result ( const automaton::RealTimeHeightDeterministicDPDA & automaton, const string::LinearString & string );
	static label::Label result ( const automaton::DPDA & automaton, const string::LinearString & string );

	static Result & getInstance ( ) {
		static Result res;

		return res;
	}

};

} /* namespace run */

} /* namespace automaton */

#endif /* _AUTOMATON_RESULT_H__ */
