/*
 * Minimize.h
 *
 *  Created on: Dec 9, 2013
 *	  Author: Jan Travnicek
 */

#ifndef MINIMIZE_H_
#define MINIMIZE_H_

#include <common/multipleDispatch.hpp>
#include <automaton/Automaton.h>
#include <automaton/FSM/DFA.h>

namespace automaton {

namespace simplify {

class Minimize : public std::SingleDispatch<automaton::Automaton, automaton::AutomatonBase> {
public:
	/**
	 * @param dfa automaton to minimize
	 */
	static automaton::Automaton minimize(const automaton::Automaton& dfa);

	static automaton::DFA minimize(const automaton::DFA& dfa);

	static Minimize& getInstance() {
		static Minimize res;
		return res;
	}
};

} /* namespace simplify */

} /* namespace automaton */

#endif /* MINIMIZE_H_ */
