/*
 * MinimizeBrzozowski.cpp
 *
 *  Created on: 18. 11. 2014
 *	  Author: Tomas Pecka
 */

#include "MinimizeBrzozowski.h"

#include <exception/AlibException.h>
#include <automaton/Automaton.h>
#include <automaton/FSM/MultiInitialStateNFA.h>

#include "../transform/Reverse.h"
#include "../determinize/Determinize.h"

namespace automaton {

namespace simplify {

automaton::Automaton MinimizeBrzozowski::minimize(const automaton::Automaton& automaton) {
	return getInstance().dispatch(automaton.getData());
}

automaton::DFA MinimizeBrzozowski::minimize(const automaton::DFA& dfa) {
	return automaton::determinize::Determinize::determinize(automaton::transform::Reverse::convert(automaton::determinize::Determinize::determinize(automaton::transform::Reverse::convert(dfa))));
}

auto MinimizeBrzozowskiDFA = MinimizeBrzozowski::RegistratorWrapper<automaton::DFA, automaton::DFA>(MinimizeBrzozowski::getInstance(), MinimizeBrzozowski::minimize);

automaton::DFA MinimizeBrzozowski::minimize(const automaton::NFA& nfa) {
	return automaton::determinize::Determinize::determinize(automaton::transform::Reverse::convert(automaton::determinize::Determinize::determinize(automaton::transform::Reverse::convert(nfa))));
}

auto MinimizeBrzozowskiNFA = MinimizeBrzozowski::RegistratorWrapper<automaton::DFA, automaton::NFA>(MinimizeBrzozowski::getInstance(), MinimizeBrzozowski::minimize);

} /* namespace simplify */

} /* namespace automaton */
