/*
 * CockeYoungerKasami.h
 *
 *  Created on: 22. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef COCKE_YOUNGER_KASAMI_H_
#define COCKE_YOUNGER_KASAMI_H_

#include <common/multipleDispatch.hpp>

#include <grammar/Grammar.h>
#include <grammar/ContextFree/CNF.h>
#include <string/LinearString.h>

namespace grammar {

namespace generate {

/**
 * Implements algorithms from Melichar, chapter 3.3
 */
class CockeYoungerKasami : public std::SingleDispatchLastStaticParam < bool, grammar::GrammarBase, const string::LinearString & > {
public:
	static bool generate ( const grammar::Grammar & grammar, const string::LinearString & string );

	static bool generate ( const grammar::CNF & grammar, const string::LinearString & string );

	static CockeYoungerKasami & getInstance ( ) {
		static CockeYoungerKasami res;

		return res;
	}

};

} /* namespace generate */

} /* namespace grammar */

#endif /* COCKE_YOUNGER_KASAMI_H_ */
