/*
 * RandomGrammarFactory.h
 *
 *  Created on: 27. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef RANDOM_GRAMMAR_FACTORY_H_
#define RANDOM_GRAMMAR_FACTORY_H_

#include <deque>
#include <set>

#include <exception/AlibException.h>
#include <grammar/ContextFree/CFG.h>

namespace grammar {

namespace generate {

class RandomGrammarFactory {
public:
	static grammar::CFG generateCFG( std::set<alphabet::Symbol> nonterminals, std::set<alphabet::Symbol> terminals, double density );
	static grammar::CFG generateCFG( size_t nonterminalsCount, size_t terminalsSize, bool randomizedAlphabet, double density );

private:
	static grammar::CFG randomCFG( const std::deque<alphabet::Symbol> & nonterminals, const std::deque<alphabet::Symbol> & terminals, double density );
};

} /* namespace generate */

} /* namespace grammar */

#endif /* RANDOM_GRAMMAR_FACTORY_H_ */
