/*
 * CornerSubstitution.cpp
 *
 *  Created on: 9. 6. 2015
 *	  Author: Jan Travnicek
 */

#include "First.h"
#include "common/Substitute.h"
#include "CornerSubstitution.h"

#include <grammar/ContextFree/CFG.h>

namespace grammar {

namespace parsing {

void CornerSubstitution::cornerSubstitution ( grammar::CFG & grammar, const alphabet::Symbol & terminal, const alphabet::Symbol & nonterminal ) {
	grammar::CFG res ( grammar.getInitialSymbol ( ) );

	res.setNonterminalAlphabet ( grammar.getNonterminalAlphabet ( ) );
	res.setTerminalAlphabet ( grammar.getTerminalAlphabet ( ) );

	for ( const std::pair < alphabet::Symbol, std::set < std::vector < alphabet::Symbol > > > & rule : grammar.getRules ( ) ) {
		const alphabet::Symbol & lhs = rule.first;

		for ( const std::vector < alphabet::Symbol > & rhs : rule.second ) {
			if ( ( lhs == nonterminal ) && ( rhs.size ( ) > 0 ) && ( grammar.getNonterminalAlphabet ( ).count ( rhs[0] ) ) && First::first ( grammar, rhs ).count ( terminal ) )
				Substitute::substitute ( grammar, res, lhs, rhs, rhs.begin ( ) );
			else
				res.addRule ( lhs, rhs );
		}
	}

	grammar = res;
}

} /* namespace parsing */

} /* namespace grammar */
