/*
 * DeterministicLL1Grammar.h
 *
 *  Created on: 9. 6. 2015
 *	  Author: Jan Travnicek
 */

#ifndef DETERMINISTIC_LL_1_GRAMMAR_H_
#define DETERMINISTIC_LL_1_GRAMMAR_H_

#include <common/multipleDispatch.hpp>
#include <grammar/Grammar.h>
#include <grammar/GrammarFeatures.h>

namespace grammar {

namespace parsing {

class DeterministicLL1Grammar : public std::SingleDispatch < grammar::Grammar, grammar::GrammarBase > {
public:
	static grammar::CFG convert ( const grammar::CFG & grammar );

	static grammar::Grammar convert ( const grammar::Grammar & grammar );

	static DeterministicLL1Grammar & getInstance ( ) {
		static DeterministicLL1Grammar res;

		return res;
	}

};

} /* namespace parsing */

} /* namespace grammar */

#endif /* DETERMINISTIC_LL_1_GRAMMAR_H_ */
