/*
 * LL1ParseTable.h
 *
 *  Created on: 9. 6. 2015
 *	  Author: Jan Travnicek
 */

#ifndef LL_1_PARSE_TABLE_H_
#define LL_1_PARSE_TABLE_H_

#include <common/multipleDispatch.hpp>
#include <grammar/Grammar.h>
#include <alphabet/Symbol.h>
#include <string/Epsilon.h>
#include <vector>
#include <variant>
#include <set>
#include <map>

namespace grammar {

namespace parsing {

class LL1ParseTable : public std::SingleDispatch < std::map < std::pair < std::variant < alphabet::Symbol, string::Epsilon >, alphabet::Symbol >, std::set < std::vector < alphabet::Symbol > > >, grammar::GrammarBase > {
public:
	template < class T >
	static std::map < std::pair < std::variant < alphabet::Symbol, string::Epsilon >, alphabet::Symbol >, std::set < std::vector < alphabet::Symbol > > > parseTable ( const T & grammar );

	static std::map < std::pair < std::variant < alphabet::Symbol, string::Epsilon >, alphabet::Symbol >, std::set < std::vector < alphabet::Symbol > > > parseTable ( const grammar::Grammar & grammar );

	static LL1ParseTable & getInstance ( ) {
		static LL1ParseTable res;

		return res;
	}

};

} /* namespace parsing */

} /* namespace grammar */

#endif /* LL_1_PARSE_TABLE_H_ */
