/*
 * GrammarPropertiesCFG.h
 *
 *  Created on: 22. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef PRODUCTIVE_NONTERMINALS_H_
#define PRODUCTIVE_NONTERMINALS_H_

#include <common/multipleDispatch.hpp>

#include <grammar/Grammar.h>
#include <alphabet/Symbol.h>

namespace grammar {

namespace properties {

/**
 * Implements algorithms from Melichar, chapter 3.3
 */
class ProductiveNonterminals : public std::SingleDispatch<std::set<alphabet::Symbol>, grammar::GrammarBase> {
public:
	static std::set<alphabet::Symbol> getProductiveNonterminals( const grammar::Grammar & grammar );

	/**
	 * Implements steps 1 through 3 in Melichar 3.6
	 */
	template<class T>
	static std::set<alphabet::Symbol> getProductiveNonterminals( const T & grammar );

	static ProductiveNonterminals& getInstance() {
		static ProductiveNonterminals res;
		return res;
	}
};

} /* namespace properties */

} /* namespace grammar */

#endif /* PRODUCTIVE_NONTERMINALS_H_ */
