/*
 * UnproductiveSymbolsRemover.h
 *
 *  Created on: 22. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef UNPRODUCTIVE_SYMBOLS_REMOVER_H_
#define UNPRODUCTIVE_SYMBOLS_REMOVER_H_

#include <common/multipleDispatch.hpp>
#include <grammar/Grammar.h>

namespace grammar {

namespace simplify {

/**
 * Implements algorithms from Melichar, chapter 3.3
 */
class UnproductiveSymbolsRemover : public std::SingleDispatch<grammar::Grammar, grammar::GrammarBase> {
public:
	static grammar::Grammar remove( const grammar::Grammar & automaton );

	/**
	 * Removes unproductive (or useless - terminology) symbols - Melichar 3.12
	 */
	template<class T>
	static T remove( const T & grammar );

	static UnproductiveSymbolsRemover& getInstance() {
		static UnproductiveSymbolsRemover res;
		return res;
	}
};

} /* namespace simplify */

} /* namespace grammar */

#endif /* UNPRODUCTIVE_SYMBOLS_REMOVER_H_ */
