/*
 * UnreachableSymbolsRemover.h
 *
 *  Created on: 22. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef UNREACHABLE_SYMBOLS_REMOVER_H_
#define UNREACHABLE_SYMBOLS_REMOVER_H_

#include <common/multipleDispatch.hpp>
#include <grammar/Grammar.h>

namespace grammar {

namespace simplify {

/**
 * Implements algorithms from Melichar, chapter 3.3
 */
class UnreachableSymbolsRemover : public std::SingleDispatch<grammar::Grammar, grammar::GrammarBase> {
public:
	static grammar::Grammar remove( const grammar::Grammar & automaton );

	/*
	 * Removes unreachable symbols - Melichar 3.9
	 */
	template<class T>
	static T remove( const T & grammar );

	static UnreachableSymbolsRemover& getInstance() {
		static UnreachableSymbolsRemover res;
		return res;
	}
};

} /* namespace simplify */

} /* namespace grammar */

#endif /* UNREACHABLE_SYMBOLS_REMOVER_H_ */
