#ifndef RANDOM_GRAPH_FACTORY_H_
#define RANDOM_GRAPH_FACTORY_H_

#include <graph/directed/DirectedGraph.h>
#include <graph/undirected/UndirectedGraph.h>

namespace graph
{

namespace generate
{

class RandomGraphFactory
{
public:
	// size - rough number of nodes, may be more but not less
	static UndirectedGraph generateUndirectedTriConnectedPlanarGraph(int size);
	static UndirectedGraph generateUndirectedIsomorphicGraph(const UndirectedGraph &graph);
};

} // namespace generate

} // namespace grammar

#endif // RANDOM_GRAPH_FACTORY_H_
