#include "HopcroftWong.h"
#include "HopcroftGraph.h"
#include "HopcroftImpl.h"

#include <exception/AlibException.h>

namespace graph
{

namespace isomorphism
{

bool HopcroftWong::hopcroftwong(const Graph &first, const Graph &second)
{
	return getInstance().dispatch(first.getData(), second.getData());
}

bool HopcroftWong::hopcroftwong(const UndirectedGraph &first, const UndirectedGraph &second)
{
	hopcroft::Graph g1(first);
	hopcroft::Graph g2(second);
	hopcroft::HopcroftImpl impl(&g1, &g2);
	return impl.testIsomorphism();
}

} // namespace isomorphism

} // namespace graph
