#ifndef GRAPH_JARNIK_PRIM_H_
#define GRAPH_JARNIK_PRIM_H_

#include <common/multipleDispatch.hpp>
#include <graph/Graph.h>
#include <graph/directed/DirectedGraph.h>
#include <graph/undirected/UndirectedGraph.h>

namespace graph {

namespace spanningtree {

class JarnikPrim : public std::SingleDispatchLastStaticParam<graph::Graph, graph::GraphBase, const Node&> {
public:
	static Graph jarnikprim(const Graph &graph, const Node &start);

	static UndirectedGraph jarnikprim(const UndirectedGraph &graph, const Node &start);

	static JarnikPrim& getInstance() {
		static JarnikPrim res;
		return res;
	}
};

} // namespace spanningtree

} // namespace graph

#endif // GRAPH_JARNIK_PRIM_H_
