/*
 * RegExpIterate.cpp
 *
 *  Created on: 17. 10. 2014
 *	  Author: Jan Travnicek
 */

#include "RegExpIterate.h"
#include "regexp/formal/FormalRegExpIteration.h"
#include "regexp/unbounded/UnboundedRegExpIteration.h"

namespace regexp {

regexp::RegExp RegExpIterate::iterate(const regexp::RegExp& regexp) {
	return getInstance().dispatch(regexp.getData());
}

regexp::FormalRegExp RegExpIterate::iterate(const regexp::FormalRegExp& regexp) {
	return regexp::FormalRegExp(regexp::FormalRegExpIteration(regexp.getRegExp()));
}

auto RegExpIterateFormalRegExpFormalRegExp = RegExpIterate::RegistratorWrapper<regexp::FormalRegExp, regexp::FormalRegExp>(RegExpIterate::getInstance(), RegExpIterate::iterate);

regexp::UnboundedRegExp RegExpIterate::iterate(const regexp::UnboundedRegExp& regexp) {
	return regexp::UnboundedRegExp(regexp::UnboundedRegExpIteration(regexp.getRegExp()));
}

auto RegExpIterateUnboundedRegExpUnboundedRegExp = RegExpIterate::RegistratorWrapper<regexp::UnboundedRegExp, regexp::UnboundedRegExp>(RegExpIterate::getInstance(), RegExpIterate::iterate);

} /* namespace regexp */
