/*
 * DeadZoneUsingBadCharacterShift.h
 *
 *  Created on: 5. 11. 2014
 *      Author: Radomir Polach, Tomas Pecka
 */

#ifndef _DEAD_ZONE_USING_BAD_CHARACTER_SHIFT_H_
#define _DEAD_ZONE_USING_BAD_CHARACTER_SHIFT_H_

#include <set>
#include <common/multipleDispatch.hpp>
#include <string/String.h>
#include <string/StringFeatures.h>

namespace stringology {

namespace exact {

/**
 * Implementation of DeadZone matching using bcs as shifting method to both directions
 */
class DeadZoneUsingBadCharacterShift : public std::DoubleDispatch < std::set < unsigned >, string::StringBase, string::StringBase > {
public:
	/**
	 * Search for pattern in linear string.
	 * @return set set of occurences
	 */
	static std::set < unsigned > match ( const string::String & subject, const string::String & pattern );

	static std::set < unsigned > match ( const string::LinearString & subject, const string::LinearString & pattern );
	static void match_rec ( std::set < unsigned > & occ, const string::LinearString & string, const string::LinearString & pattern, std::map < alphabet::Symbol, size_t > & fbcs, std::map < alphabet::Symbol, size_t > & bbcs, int low, int high );

	static DeadZoneUsingBadCharacterShift & getInstance ( ) {
		static DeadZoneUsingBadCharacterShift res;

		return res;
	}

};

} /* namespace exact */

} /* namespace stringology */

#endif /* _DEAD_ZONE_USING_BAD_CHARACTER_SHIFT_H_ */
