/*
 * VariablesBarSymbol.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "VariablesBarSymbol.h"
#include "../sax/FromXMLParserHelper.h"
#include "Symbol.h"
#include "../object/Object.h"
#include "../XmlApi.hpp"
#include "UniqueSymbol.h"

namespace alphabet {

VariablesBarSymbol::VariablesBarSymbol ( ) {
}

SymbolBase * VariablesBarSymbol::clone ( ) const {
	return new VariablesBarSymbol ( * this );
}

SymbolBase * VariablesBarSymbol::plunder ( ) && {
	return new VariablesBarSymbol ( std::move ( * this ) );
}

int VariablesBarSymbol::compare ( const VariablesBarSymbol & ) const {
	return 0;
}

void VariablesBarSymbol::operator >>( std::ostream & out ) const {
	out << "(Variables bar symbol)";
}

VariablesBarSymbol::operator std::string ( ) const {
	return "|";
}

VariablesBarSymbol VariablesBarSymbol::BAR = VariablesBarSymbol ( );

const std::string VariablesBarSymbol::XML_TAG_NAME = "VariablesBarSymbol";

VariablesBarSymbol VariablesBarSymbol::parse ( std::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, VariablesBarSymbol::XML_TAG_NAME );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, VariablesBarSymbol::XML_TAG_NAME );

	return VariablesBarSymbol ( );
}

void VariablesBarSymbol::compose ( std::deque < sax::Token > & out ) const {
	out.emplace_back ( VariablesBarSymbol::XML_TAG_NAME, sax::Token::TokenType::START_ELEMENT );
	out.emplace_back ( VariablesBarSymbol::XML_TAG_NAME, sax::Token::TokenType::END_ELEMENT );
}

SymbolBase * VariablesBarSymbol::next ( ) const {
	return new UniqueSymbol ( Symbol ( * this ), primitive::Integer ( 0 ) );
}

SymbolBase * VariablesBarSymbol::inc ( ) && {
	return new UniqueSymbol ( Symbol ( std::move ( * this ) ), primitive::Integer ( 0 ) );
}

} /* namespace alphabet */

namespace alib {

auto variablesBarSymbolParserRegister = xmlApi < alphabet::Symbol >::ParserRegister < alphabet::VariablesBarSymbol > ();
auto variablesBarSymbolParserRegister2 = xmlApi < alib::Object >::ParserRegister < alphabet::VariablesBarSymbol > ();

} /* namespace alib */
