/*
 * Automaton.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Martin Zak
 */

#include "Automaton.h"
#include "common/State.h"
#include <climits>
#include "AutomatonException.h"
#include "../XmlApi.hpp"

namespace automaton {

const std::string Automaton::XML_TAG_NAME_REF = "AutomatonRef";

State createUniqueState ( State nextState, const std::set < State > & other ) {
	int i = 0;

	do {
		nextState.getName ( ).inc ( );

		if ( other.count ( nextState ) == 0 )
			return nextState;
	} while ( ++i < INT_MAX );

	throw AutomatonException ( "Could not create unique state." );
}

} /* namespace automaton */

namespace alib {

auto AutomatonDeleter = xmlApi < automaton::Automaton >::InputContextDeleter ( );
}
