/*
 * AutomatonBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef AUTOMATON_BASE_H_
#define AUTOMATON_BASE_H_

#include "../object/ObjectBase.h"
#include "../exception/AlibException.h"

namespace automaton {

/**
 * Represents symbol in an alphabet.
 */
class AutomatonBase : public alib::ObjectBase {
public:
	virtual AutomatonBase* clone() const = 0;
	virtual AutomatonBase* plunder() && = 0;
};

} /* namespace automaton */

namespace std {

template<>
struct compare<automaton::AutomatonBase> {
	int operator()(const automaton::AutomatonBase& first, const automaton::AutomatonBase& second) const {
		return first.compare(second);
	}
};

} /* namespace std */

#endif /* AUTOMATON_BASE_H_ */

