/*
 * BottomOfTheStackSymbolPushdownStoreAlphabet.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef BOTTOM_OF_THE_STACK_SYMBOL_PUSHDOWN_STORE_ALPHABET_H_
#define BOTTOM_OF_THE_STACK_SYMBOL_PUSHDOWN_STORE_ALPHABET_H_

#include <set>
#include "../../alphabet/Symbol.h"
#include "PushdownStoreAlphabet.h"

namespace automaton {

/**
 * Push Down Automaton
 */
class BottomOfTheStackSymbolPushdownStoreAlphabet : public PushdownStoreAlphabet {
protected:
	alphabet::Symbol bottomOfTheStackSymbol;
public:
	BottomOfTheStackSymbolPushdownStoreAlphabet(alphabet::Symbol bottomOfTheStackSymbol);

	/**
	 * Set bottomOfTheStack symbol. BottomOfTheStack symbol is symbol that is pushed
	 * to the stack when BottomOfTheStackSymbolPushdownStoreAlphabet is created.
	 * @param start new bottomOfTheStack symbol
	 * @throws AutomatonException when symbol is not present in the stack alphabet
	 */
	void setBottomOfTheStackSymbol(alphabet::Symbol start);

	/**
	 * @return list of start symbols
	 */
	const alphabet::Symbol& getBottomOfTheStackSymbol() const;

};

} /* namespace automaton */

#endif /* BOTTOM_OF_THE_STACK_SYMBOL_PUSHDOWN_STORE_ALPHABET_H_ */
