/*
 * Grammar.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef GRAMMAR_H_
#define GRAMMAR_H_

#include "../object/WrapperBase.h"
#include "GrammarBase.h"
#include "../common/wrapper.hpp"

namespace grammar {

/**
 * Wrapper around grammars.
 */
class Grammar : public alib::wrapper < GrammarBase >, public alib::WrapperBase {
	using alib::wrapper < GrammarBase >::wrapper;

public:
	const static std::string XML_TAG_NAME_REF;
};

} /* namespace grammar */

namespace std {

template < >
struct compare < grammar::Grammar > {
	int operator ()( const grammar::Grammar & first, const grammar::Grammar & second ) const {
		return first.getData ( ).compare ( second.getData ( ) );
	}

};

} /* namespace std */

#endif /* GRAMMAR_H_ */
