/*
 * GrammarBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef GRAMMAR_BASE_H_
#define GRAMMAR_BASE_H_

#include "../object/ObjectBase.h"
#include "../exception/AlibException.h"

namespace grammar {

/**
 * Represents symbol in an alphabet.
 */
class GrammarBase : public alib::ObjectBase {
public:
	virtual GrammarBase* clone() const = 0;
	virtual GrammarBase* plunder() && = 0;
};

} /* namespace grammar */

namespace std {

template<>
struct compare<grammar::GrammarBase> {
	int operator()(const grammar::GrammarBase& first, const grammar::GrammarBase& second) const {
		return first.compare(second);
	}
};

} /* namespace std */

#endif /* GRAMMAR_BASE_H_ */

