/*
 * GraphFeatures.h
 *
 *  Created on: Jun 19, 2014
 *      Author: David Rosca
 */

#ifndef GRAPH_MACROS_H_
#define GRAPH_MACROS_H_

#define GRAPH_DEFINE_STD_HASH(T) \
	namespace std { \
	template <> \
	struct hash<graph::T> \
	{ \
		std::size_t operator()(const graph::T &t) const \
		{ \
			return std::hash<std::string>()(static_cast<std::string>(t)); \
		} \
	}; \
	} \

#define GRAPH_DEFINE_STD_COMPARE(T) \
	namespace std { \
	template<> \
	struct compare<graph::T> \
	{ \
		int operator()(const graph::T &first, const graph::T &second) const \
		{ \
			return first.compare(second); \
		} \
	}; \
	} \

#endif // GRAPH_MACROS_H_
