/*
 * IndexToXMLComposer.h
 *
 *  Created on: Nov 16, 2014
 *      Author: Jan Travnicek
 */

#ifndef INDEX_TO_XML_COMPOSER_H_
#define INDEX_TO_XML_COMPOSER_H_

#include <deque>
#include <set>
#include "../../alphabet/SymbolFeatures.h"
#include "../../sax/Token.h"
#include "../suffixTrie/SuffixTrieNodeFinalMark.h"
#include "../suffixTrie/SuffixTrieNodeTerminatingSymbol.h"

namespace indexes {

/**
 * This class contains methods to print XML representation of indexes to the output stream.
 */
class IndexToXMLComposer {
public:
	static void composeAlphabet ( std::deque < sax::Token > & out, const std::set < alphabet::Symbol > & symbols );

	static void composeNode ( std::deque < sax::Token > & out, const SuffixTrieNodeFinalMark & node );
	static void composeNode ( std::deque < sax::Token > & out, const SuffixTrieNodeTerminatingSymbol & node );
};

} /* namespace indexes */

#endif /* INDEX_TO_XML_COMPOSER_H_ */
