/*
 * Label.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_H_
#define LABEL_H_

#include "../object/WrapperBase.h"
#include "LabelBase.h"
#include "../common/wrapper.hpp"

namespace label {

/**
 * Wrapper around automata.
 */
class Label : public alib::wrapper < LabelBase >, public alib::WrapperBase {
	using alib::wrapper < LabelBase >::wrapper;

public:
	Label next ( ) const;
	void inc ( );

	const static std::string XML_TAG_NAME_REF;
};

label::Label labelFrom ( int number );
label::Label labelFrom ( int number1, int number2 );
label::Label labelFrom ( char character );
label::Label labelFrom ( std::string string );
label::Label labelFrom ( const char * string );

} /* namespace label */

namespace std {

template < >
struct compare < label::Label > {
	int operator ()( const label::Label & first, const label::Label & second ) const {
		return first.getData ( ).compare ( second.getData ( ) );
	}

};

} /* namespace std */

#endif /* LABEL_H_ */
