/*
 * RegExp.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef REG_EXP_H_
#define REG_EXP_H_

#include "../object/WrapperBase.h"
#include "../common/wrapper.hpp"
#include "RegExpBase.h"

#include "../alphabet/SymbolFeatures.h"
#include "../string/StringFeatures.h"
#include <string>
#include <set>

namespace regexp {

/**
 * Wrapper around automata.
 */
class RegExp : public alib::wrapper < RegExpBase >, public alib::WrapperBase {
	using alib::wrapper < RegExpBase >::wrapper;

public:
	const std::set < alphabet::Symbol > & getAlphabet ( ) const;

	const static std::string XML_TAG_NAME_REF;
};

regexp::RegExp regexpFrom ( const std::string & string );

regexp::RegExp regexpFrom ( const char * string );

regexp::RegExp regexpFrom ( string::LinearString string );

regexp::RegExp regexpFrom ( alphabet::Symbol symbol );

regexp::RegExp regexpFrom ( );

} /* namespace regexp */

namespace std {

template < >
struct compare < regexp::RegExp > {
	int operator ()( const regexp::RegExp & first, const regexp::RegExp & second ) const {
		return first.getData ( ).compare ( second.getData ( ) );
	}

};

} /* namespace std */

#endif /* REG_EXP_H_ */
