/*
 * FormalRegExpElement.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Martin Zak
 */

#include "FormalRegExpElement.h"
#include <typeinfo>

#include "FormalRegExpElements.h"

#include "../common/RegExpFromXMLParser.h"
#include "../common/RegExpToXMLComposer.h"
#include "../../exception/AlibException.h"

namespace regexp {

FormalRegExpElement::FormalRegExpElement ( ) : parentRegExp ( NULL ) {
}

} /* namespace regexp */

namespace alib {

regexp::FormalRegExpElement * xmlApi < regexp::FormalRegExpElement * >::parse ( std::deque < sax::Token >::iterator & input ) {
	return regexp::RegExpFromXMLParser::parseFormalRegExpElement ( input );
}

bool xmlApi < regexp::FormalRegExpElement * >::first ( const std::deque < sax::Token >::const_iterator & ) {
	throw exception::AlibException ( "Unimplemented" );
}

void xmlApi < regexp::FormalRegExpElement * >::compose ( std::deque < sax::Token > & output, const regexp::FormalRegExpElement * const & data ) {
	data->Accept ( ( void * ) & output, regexp::RegExpToXMLComposer::REGEXP_TO_XML_COMPOSER );
}

void xmlApi < const regexp::FormalRegExpElement * >::compose ( std::deque < sax::Token > & output, const regexp::FormalRegExpElement * const & data ) {
	data->Accept ( ( void * ) & output, regexp::RegExpToXMLComposer::REGEXP_TO_XML_COMPOSER );
}

} /* namespace alib */
