/*
 * StringFromXMLParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_FROM_XML_PARSER_H_
#define STRING_FROM_XML_PARSER_H_

#include <vector>
#include <set>
#include <deque>
#include "../../sax/Token.h"
#include "../../alphabet/Symbol.h"

namespace string {

/**
 * Parser used to get String from XML parsed into list of tokens.
 */
class StringFromXMLParser {
public:
	static std::vector<alphabet::Symbol> parseContent(std::deque<sax::Token>::iterator& input);
	static std::set<alphabet::Symbol> parseAlphabet(std::deque<sax::Token>::iterator& input);
};

} /* namespace string */

#endif /* STRING_FROM_XML_PARSER_H_ */
