/*
 * StringToXMLComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "StringToXMLComposer.h"
#include "../../XmlApi.hpp"

namespace string {

void StringToXMLComposer::compose(std::deque<sax::Token>& out, const std::set<alphabet::Symbol>& alphabet) {
	out.emplace_back("alphabet", sax::Token::TokenType::START_ELEMENT);
	for (const auto& symbol : alphabet) {
		alib::xmlApi<alphabet::Symbol>::compose(out, symbol);
	}
	out.emplace_back("alphabet", sax::Token::TokenType::END_ELEMENT);
}

void StringToXMLComposer::compose(std::deque<sax::Token>& out, const std::vector<alphabet::Symbol>& content) {
	out.emplace_back("content", sax::Token::TokenType::START_ELEMENT);
	for(const auto& symbol : content) {
		alib::xmlApi<alphabet::Symbol>::compose(out, symbol);
	}
	out.emplace_back("content", sax::Token::TokenType::END_ELEMENT);
}

} /* namespace string */
