/*
 * TreeFromXMLParser.h
 *
 *  Created on: Nov 16, 2014
 *      Author: Stepan Plachy
 */

#ifndef TREE_FROM_XML_PARSER_H_
#define TREE_FROM_XML_PARSER_H_

#include <set>
#include <vector>
#include <deque>

#include "../../sax/Token.h"
#include "../../alphabet/SymbolFeatures.h"
#include "../ranked/RankedNode.h"
#include "../unranked/UnrankedNode.h"

namespace tree {

/**
 * Parser used to get tree from XML parsed into list of Tokens.
 */
class TreeFromXMLParser {
public:
	static RankedNode * parseRankedNode ( std::deque < sax::Token >::iterator & input );
	static UnrankedNode * parseUnrankedNode ( std::deque < sax::Token >::iterator & input );
	static std::vector < alphabet::RankedSymbol > parseRankedContent ( std::deque < sax::Token >::iterator & input );
	static std::vector < alphabet::Symbol > parseUnrankedContent ( std::deque < sax::Token >::iterator & input );
	static std::set < alphabet::RankedSymbol > parseRankedAlphabet ( std::deque < sax::Token >::iterator & input );
	static std::set < alphabet::Symbol > parseUnrankedAlphabet ( std::deque < sax::Token >::iterator & input );

	static alphabet::Symbol parseBar ( std::deque < sax::Token >::iterator & input );
	static alphabet::Symbol parseVariablesBar ( std::deque < sax::Token >::iterator & input );

	static alphabet::Symbol parseSubtreeWildcardSymbol ( std::deque < sax::Token >::iterator & input );
	static alphabet::RankedSymbol parseSubtreeWildcardRankedSymbol ( std::deque < sax::Token >::iterator & input );
};

} /* namespace tree */

#endif /* TREE_FROM_XML_PARSER_H_ */
