/*
 * UnrankedPatternAlphabet.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef UNRANKED_PATTERN_ALPHABET_H_
#define UNRANKED_PATTERN_ALPHABET_H_

#include "UnrankedAlphabet.h"

namespace tree {

/**
 * Abstract base class for all strings. Contains common elements of strings.
 */
class UnrankedPatternAlphabet : public UnrankedAlphabet {
protected:
	alphabet::Symbol subtreeWildcard;

public:
	UnrankedPatternAlphabet(alphabet::Symbol subtreeWildcard);

	/**
	 * Sets the subtree variable = symbol representing subtree substitution place in the pattern
	 * @param symbol Symbol to set
	 */
	void setSubtreeWildcard(alphabet::Symbol symbol);

	/**
	 * @return symbol representing subtree variable
	 */
	const alphabet::Symbol& getSubtreeWildcard() const;

};

} /* namespace tree */

#endif /* UNRANKED_PATTERN_ALPHABET_H_ */

