#ifndef GRAPH_TEST_H_
#define GRAPH_TEST_H_

#include <cppunit/extensions/HelperMacros.h>

#include "graph/directed/DirectedGraph.h"
#include "graph/undirected/UndirectedGraph.h"

class GraphTest : public CppUnit::TestFixture
{
	CPPUNIT_TEST_SUITE(GraphTest);
	CPPUNIT_TEST(testCopyConstruct);
	CPPUNIT_TEST(testEqual);
	CPPUNIT_TEST(testXMLParser);
	CPPUNIT_TEST(testAddEdge);
	CPPUNIT_TEST(testRemoveEdge);
	CPPUNIT_TEST(testAddNode);
	CPPUNIT_TEST(testRemoveNode);
	CPPUNIT_TEST(testNeighborEdges);
	CPPUNIT_TEST(testHasEdge);
	CPPUNIT_TEST(testAddEdgeValue);
	CPPUNIT_TEST(testHasNodeAndEdge);
	CPPUNIT_TEST_SUITE_END();

public:
	void testCopyConstruct();
	void testEqual();
	void testXMLParser();

	void testAddEdge();
	void testRemoveEdge();
	void testAddNode();
	void testRemoveNode();
	void testNeighborEdges();
	void testHasEdge();
	void testAddEdgeValue();
	void testHasNodeAndEdge();

	void testCopyConstruct_impl(graph::REPRESENTATION representation);
	void testEqual_impl(graph::REPRESENTATION representation);
	void testXMLParser_impl(graph::REPRESENTATION representation);

	void testAddEdge_impl(graph::REPRESENTATION representation);
	void testRemoveEdge_impl(graph::REPRESENTATION representation);
	void testAddNode_impl(graph::REPRESENTATION representation);
	void testRemoveNode_impl(graph::REPRESENTATION representation);
	void testNeighborEdges_impl(graph::REPRESENTATION representation);
	void testHasEdge_impl(graph::REPRESENTATION representation);
	void testAddEdgeValue_impl(graph::REPRESENTATION representation);
	void testHasNodeAndEdge_impl(graph::REPRESENTATION representation);
};

#endif	// GRAPH_TEST_H_
