/*
 * Author: Radovan Cerveny
 */
#include "MeasurementTypes.hpp"

namespace measurements {

std::string to_string ( Type t ) {
	switch ( t ) {
	case Type::ROOT:
		return "ROOT";

	case Type::OVERALL:
		return "OVERALL";

	case Type::INIT:
		return "INIT";

	case Type::FINALIZE:
		return "FINALIZE";

	case Type::MAIN:
		return "MAIN";

	case Type::AUXILIARY:
		return "AUXILIARY";
	}

	return "ERR";
}

std::ostream & operator <<( std::ostream & os, Type t ) {
	os << to_string ( t );
	return os;
}

std::string to_string ( const stealth_string & ss ) {
	return ss.c_str ( );
}

std::string to_string ( stealth_string & ss ) {
	return ss.c_str ( );
}

}
