/*
 * Author: Radovan Cerveny
 */

#include "measurements.hpp"

namespace measurements {

void start ( measurements::stealth_string name, measurements::Type type ) {
	MeasurementEngine::INSTANCE.push_measurement_frame ( std::move ( name ), type );
}

void end ( ) {
	MeasurementEngine::INSTANCE.pop_measurement_frame ( );
}

void reset ( ) {
	MeasurementEngine::INSTANCE.reset_measurements ( );
}

MeasurementResults results ( ) {
	return MeasurementEngine::INSTANCE.get_results ( );
}

template < typename Hint >
void hint ( Hint hint ) {
	MeasurementEngine::INSTANCE.hint ( std::move ( hint ) );
}

template < >
void hint ( MemoryHint hint ) {
	MeasurementEngine::INSTANCE.hint ( std::move ( hint ) );
}

template < >
void hint ( CounterHint hint ) {
	MeasurementEngine::INSTANCE.hint ( std::move ( hint ) );
}

}
