#include "MeasurementsTest.h"
#include "sax/SaxComposeInterface.h"
#include <thread>
#include <cmath>
#include <measure>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( MeasurementsTest, "measurements" );
CPPUNIT_TEST_SUITE_REGISTRATION ( MeasurementsTest );

void MeasurementsTest::setUp ( ) {
	measurements::reset ( );
}

void MeasurementsTest::tearDown ( ) {
}

void MeasurementsTest::testTimeMeasurements ( ) {
	measurements::start ( "global", measurements::Type::OVERALL );
	measurements::start ( "init", measurements::Type::INIT );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 100 ) );
	measurements::end ( );
	measurements::start ( "main", measurements::Type::MAIN );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 20 ) );
	measurements::start ( "aux", measurements::Type::AUXILIARY );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 40 ) );
	measurements::end ( );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 80 ) );
	measurements::start ( "aux", measurements::Type::AUXILIARY );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 40 ) );
	measurements::end ( );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 80 ) );
	measurements::end ( );
	measurements::start ( "fin", measurements::Type::FINALIZE );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 30 ) );
	measurements::start ( "aux", measurements::Type::AUXILIARY );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 40 ) );
	measurements::end ( );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 80 ) );
	measurements::end ( );
	measurements::end ( );
	measurements::start ( "global2", measurements::Type::OVERALL );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 100 ) );
	measurements::end ( );
	measurements::start ( "global3", measurements::Type::OVERALL );
	measurements::start ( "init", measurements::Type::INIT );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 100 ) );
	measurements::end ( );
	measurements::start ( "main", measurements::Type::MAIN );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 20 ) );
	measurements::start ( "aux", measurements::Type::AUXILIARY );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 40 ) );
	measurements::end ( );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 80 ) );
	measurements::start ( "aux", measurements::Type::AUXILIARY );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 40 ) );
	measurements::end ( );
	std::this_thread::sleep_for ( std::chrono::milliseconds ( 80 ) );
	measurements::end ( );
	measurements::end ( );

	std::cout << measurements::MeasurementFormat::LIST << measurements::results ( ) << std::endl;
	std::cout << measurements::MeasurementFormat::TREE << measurements::results ( ) << std::endl;
	std::cout << measurements::MeasurementFormat::XML << measurements::results ( ) << std::endl;
}

void MeasurementsTest::testMemoryMeasurements ( ) {

	measurements::start ( "chunk1", measurements::Type::MAIN );
	int * baz = new int[500];

	delete[] baz;
	measurements::end ( );

	measurements::start ( "chunk2", measurements::Type::MAIN );
	int * foo = new int[1000];
	measurements::start ( "chunk21", measurements::Type::MAIN );
	int * bar = new int[2000];
	measurements::end ( );
	delete[] foo;
	delete[] bar;
	measurements::end ( );

	std::cout << measurements::MeasurementFormat::LIST << measurements::results ( ) << std::endl;
	std::cout << measurements::MeasurementFormat::TREE << measurements::results ( ) << std::endl;
	std::cout << measurements::MeasurementFormat::XML << measurements::results ( ) << std::endl;
}

void MeasurementsTest::testCounterMeasurements ( ) {

	measurements::start ( "chunk1", measurements::Type::MAIN );
	measurements::hint( measurements::CounterHint { "test1", measurements::CounterHint::Type::ADD, 5 } );
	measurements::hint( measurements::CounterHint { "test2", measurements::CounterHint::Type::INC, 0 } );
	measurements::start ( "chunk11", measurements::Type::MAIN );
	measurements::hint( measurements::CounterHint { "test3", measurements::CounterHint::Type::DEC, 0} );
	measurements::start ( "chunk111", measurements::Type::MAIN );
	measurements::hint( measurements::CounterHint { "test1", measurements::CounterHint::Type::DEC, 0 } );
	measurements::hint( measurements::CounterHint { "test2", measurements::CounterHint::Type::SUB, 10 } );
	measurements::hint( measurements::CounterHint { "test3", measurements::CounterHint::Type::DEC, 0} );
	measurements::hint( measurements::CounterHint { "test4", measurements::CounterHint::Type::DEC, 0} );
	measurements::end ( );
	measurements::start ( "chunk112", measurements::Type::MAIN );
	measurements::hint( measurements::CounterHint { "test1", measurements::CounterHint::Type::DEC, 0 } );
	measurements::hint( measurements::CounterHint { "test2", measurements::CounterHint::Type::SUB, 10 } );
	measurements::hint( measurements::CounterHint { "test3", measurements::CounterHint::Type::DEC, 0} );
	measurements::hint( measurements::CounterHint { "test4", measurements::CounterHint::Type::DEC, 0} );
	measurements::end ( );
	measurements::end ( );
	measurements::end ( );

	std::cout << measurements::MeasurementFormat::LIST << measurements::results ( ) << std::endl;
	std::cout << measurements::MeasurementFormat::TREE << measurements::results ( ) << std::endl;
	std::cout << measurements::MeasurementFormat::XML << measurements::results ( ) << std::endl;
}