/*
 * TreeFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef TREE_FROM_STRING_PARSER_H_
#define TREE_FROM_STRING_PARSER_H_

#include "tree/TreeFeatures.h"
#include "TreeFromStringLexer.h"

#include <set>

namespace alib {

template < typename T >
struct stringApi;

} /* namespace alib */

namespace tree {

class TreeFromStringParser {
public:
	TreeFromStringParser ( ) { }

private:
	tree::RankedNode * parseRankedContent ( std::istream &, bool & ) const;
	tree::UnrankedNode * parseUnrankedContent ( std::istream &, bool & ) const;

	TreeFromStringLexer m_TreeLexer;

	tree::Tree parseTree ( std::istream & ) const;
	tree::Tree parseTree ( std::istream &, const std::set < FEATURES > & features ) const;

	template < typename T >
	friend struct alib::stringApi;
};

} /* namespace tree */

#endif /* TREE_FROM_STRING_PARSER_H_ */
