/*
 * RegExpStat.h
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#ifndef REG_EXP_STAT_H_
#define REG_EXP_STAT_H_

#include <common/multipleDispatch.hpp>

#include "regexp/RegExp.h"
#include "regexp/RegExpFeatures.h"

#include "RegExpSettings.h"

class RegExpStat : public std::SingleDispatchLastStaticParam < void, regexp::RegExpBase, const RegExpSettings & > {
	static unsigned countNodes ( const regexp::FormalRegExpElement & node );

	static unsigned countNodes ( const regexp::UnboundedRegExpElement & node );

public:
	static void stat ( const regexp::RegExp & regexp, const RegExpSettings & settings );

	static void stat ( const regexp::UnboundedRegExp & regexp, const RegExpSettings & settings );
	static void stat ( const regexp::FormalRegExp & regexp, const RegExpSettings & settings );

	static RegExpStat & getInstance ( ) {
		static RegExpStat res;

		return res;
	}

};

#endif /* REG_EXP_STAT_H_ */
