/*
 * SetStat.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#include "SetStat.h"

#include <exception/AlibException.h>

#include <factory/XmlDataFactory.hpp>
#include <iostream>

void SetStat::stat ( const container::ObjectsSet & data, const SetSettings & settings ) {
	switch ( settings.general ) {
	case PrintingOptions::PRINT:
		alib::XmlDataFactory::toStdout ( data );
		break;

	case PrintingOptions::SIZE:
		std::cout << data.size ( ) << std::endl;
		break;

	case PrintingOptions::BOTH:
		std::cout << data.size ( ) << std::endl;
		alib::XmlDataFactory::toStdout ( data );
		break;

	case PrintingOptions::NOOP:
		break;
	}
}

void SetStat::stat ( const label::LabelSetLabel & data, const SetSettings & settings ) {
	switch ( settings.general ) {
	case PrintingOptions::PRINT:
		alib::XmlDataFactory::toStdout ( data );
		break;

	case PrintingOptions::SIZE:
		std::cout << data.getData ( ).size ( ) << std::endl;
		break;

	case PrintingOptions::BOTH:
		std::cout << data.getData ( ).size ( ) << std::endl;
		alib::XmlDataFactory::toStdout ( data );
		break;

	case PrintingOptions::NOOP:
		break;
	}
}

void SetStat::stat ( const alphabet::SymbolSetSymbol & data, const SetSettings & settings ) {
	switch ( settings.general ) {
	case PrintingOptions::PRINT:
		alib::XmlDataFactory::toStdout ( data );
		break;

	case PrintingOptions::SIZE:
		std::cout << data.getData ( ).size ( ) << std::endl;
		break;

	case PrintingOptions::BOTH:
		std::cout << data.getData ( ).size ( ) << std::endl;
		alib::XmlDataFactory::toStdout ( data );
		break;

	case PrintingOptions::NOOP:
		break;
	}
}
