/*
 * TreeStat.h
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#ifndef TREE_STAT_H_
#define TREE_STAT_H_

#include <common/multipleDispatch.hpp>

#include "tree/Tree.h"
#include "tree/TreeFeatures.h"

#include "TreeSettings.h"

class TreeStat : public std::SingleDispatchLastStaticParam < void, tree::TreeBase, const TreeSettings & > {
	static unsigned countNodes ( const tree::RankedNode & node );

	static unsigned countNodes ( const tree::UnrankedNode & node );

public:
	static void stat ( const tree::Tree & tree, const TreeSettings & settings );

	static void stat ( const tree::RankedTree & tree, const TreeSettings & settings );
	static void stat ( const tree::UnrankedTree & tree, const TreeSettings & settings );

	static TreeStat & getInstance ( ) {
		static TreeStat res;

		return res;
	}

};

#endif /* TREE_STAT_H_ */
